<template>
  <div class="dashboard-editor-container">
    <el-row type="flex" align="middle" class="header-filter">
      <el-col :span="12">
        <h2>Data Petani</h2>
      </el-col>
      <el-col :span="12">
        <a v-on:click="openFilter()" class="link-right">
          <span>{{ isOpen ? "Tutup" : "Buka" }} Filter</span>
          <svg-icon icon-class="filter" class="bigger" />
        </a>
      </el-col>
    </el-row>
    <transition name="fade">
      <filter-component @updateParams="updateParams" v-show="this.isOpen" />
    </transition>
    <user-chart />
    <panel-group @handleSetLineChartData="handleSetLineChartData" v-bind:farmers="farmers" />
    <el-row :gutter="32">
      <el-col :xs="24" :sm="24" :lg="16">
        <el-row :gutter="32">
          <el-col :xs="24" :sm="24" :lg="24">
            <div class="chart-wrapper">
              <h3 class="--green">Status Petani</h3>
              <hr />
              <farmer-status />
            </div>
          </el-col>
        </el-row>
        <el-row :gutter="32">
          <el-col :xs="24" :sm="24" :lg="24">
            <div class="chart-wrapper">
              <h3 class="--green">Lokasi Petani</h3>
              <hr />
              <location-chart />
            </div>
          </el-col>
        </el-row>
      </el-col>
      <el-col :xs="24" :sm="24" :lg="8">
        <div class="chart-wrapper">
          <h3 class="--green">Jenis Kelamin</h3>
          <hr class="overflow"/>
          <gender-list />
        </div>
        <div class="chart-wrapper">
          <h3 class="--green">Komoditas Yang Ditanam</h3>
          <hr class="overflow"/>
          <commodities-stats />
        </div>
      </el-col>
    </el-row>
    <list-farmer v-bind:params="this.params"/>
  </div>
</template>

<script>
// import GithubCorner from '@/components/GithubCorner';
import PanelGroup from './components/PanelGroup';
import LineChart from './components/LineChart';
import GenderChart from './components/GenderChart';
import LocationChart from './components/LocationChart';
import CommoditiesStats from './components/CommoditiesStats';
import ListFarmer from './components/ListFarmer';
import FilterComponent from './components/FilterComponent';
import AppActivity from './components/AppActivity';
import GenderList from './components/GenderList';
import FarmerStatus from './components/FarmerStatus';
import UserChart from './components/UserChart.vue';

const lineChartData = {
  newVisitis: {
    expectedData: [100, 120, 161, 134, 105, 160, 165],
    actualData: [120, 82, 91, 154, 162, 140, 145]
  },
  messages: {
    expectedData: [200, 192, 120, 144, 160, 130, 140],
    actualData: [180, 160, 151, 106, 145, 150, 130]
  },
  purchases: {
    expectedData: [80, 100, 121, 104, 105, 90, 100],
    actualData: [120, 90, 100, 138, 142, 130, 130]
  },
  shoppings: {
    expectedData: [130, 140, 141, 142, 145, 150, 160],
    actualData: [120, 82, 91, 154, 162, 140, 130]
  }
};

export default {
  name: 'DashboardAdmin',
  components: {
    PanelGroup,
    LineChart,
    LocationChart,
    CommoditiesStats,
    GenderChart,
    ListFarmer,
    FilterComponent,
    AppActivity,
    GenderList,
    FarmerStatus,
    UserChart
  },
  data() {
    return {
      isOpen: false,
      lineChartData: lineChartData.newVisitis,
      chartData: [['Gender', 'Value'], ['Male', 300], ['Female', 110]],
      chartOptions: {
        chart: {
          title: 'Company Performance',
          subtitle: 'Sales, Expenses, and Profit: 2014-2017'
        },
        height: 500,
        pieHole: 0.5,
        pieSliceText: 'value',
        slices: [{ color: '#76be40' }, { color: '#f9bc3f' }, { color: '#086939' }, { color: '#b9e4ac' }],
        legend: { position: 'left', align: 'center' },
        tooltip: {
          ignoreBounds: true,
          isHtml: true
        }
      },
      params: {}
    };
  },
  created() {
    this.getData();
  },
  computed: {
    farmers: {
      get: function() {
        return this.$store.state.farmer.farmers;
      }
    }
  },
  methods: {
    handleSetLineChartData(type) {
      this.lineChartData = lineChartData[type];
    },
    openFilter() {
      this.isOpen = !this.isOpen;
    },
    updateParams(params) {
      this.openFilter();
      this.params = {
        gender: params.gender,
        id_city: params.city.join(),
        commodity: params.commodity.join(),
        status_id: params.status,
        qFrom: params.value1,
        qTo: params.value2
      };
      this.getData();
    },
    getData() {
      this.$store.dispatch('totalRegisteredFarmer', this.params);
      this.$store.dispatch('totalFarmerhasField', this.params);
      this.$store.dispatch('totalFarmerhasCommodity', this.params);
      this.$store.dispatch('totalActiveFarmer', this.params);
      this.$store.dispatch('getFarmerByGender', this.params);
      this.$store.dispatch('getAllCommodity', this.params);
      this.$store.dispatch('getAllField', this.params);
      this.$store.dispatch('getFarmerByStatus', this.params);
      this.$store.dispatch('getCommodityPlant', this.params);
      this.$store.dispatch('countFarmerByLocation', this.params);
      this.$store.dispatch('getAppActivities', this.params);
    }
  }
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
@import '@/styles/variables.scss';
@import '@/styles/mixin.scss';
.dashboard-editor-container {
  padding: 32px;
  /* background-color: rgb(240, 242, 245); */
  .header-filter {
    h2 {
      font-size: 32px;
      color: #086939;
    }
    .link-right {
      font-size: 16px;
      color: #086939;
      font-weight: bold;
      float: right;
      span {
        margin-right: 9px;
      }
      .bigger.svg-icon {
        width: 23px;
        height: 23px;
        margin-bottom: -5px;
      }
    }
  }
  .el-row--shaded {
    @include ritx-box;
  }
  .chart-wrapper {
    background: #fff;
    padding: 16px;
    margin-bottom: 32px;
    @include ritx-box;
  }
  .commodity-container {
    display: flex;
  }
}

hr.overflow {
  margin-left: -15px;
  margin-right: -15px;
}
</style>
